#include "defines.h"
#include "main.h"
#include "spi.h"
#include "timer.h"
#include "sensor_processing.h"
//#include "terminal.h"

int main(void)
{   

   uint8_t MODE_count;
   uint8_t MODE;
   uint8_t base_step;
   uint8_t mode_base;
   uint8_t count_var;
   //uint16_t PCO;
    //uint8_t led_count;
    //uint8_t count_slider;

   uint8_t runc;
   uint16_t pre_c1;
   uint16_t summe1;
   uint8_t i2_touch;
   uint8_t new_touch;
   uint16_t rel_c1;
   uint16_t rel_old_c;
   uint8_t abs_c1;
   uint8_t rel_temp_c;
   uint8_t abs_old_c;
    
   MODE=0;
   MODE_count=0;
   base_step=0;
   mode_base=0;
   count_var=0;
   baseupdate=baseupdate0;

    //terminal_init(); // RS232 converter chip needed

    SPI_MasterInit();
    
    // Port init
    DDRC=0x1F;    //Port C 0-4 Output
   PORTC = 0b00010000;
    DDRD=0x7F;    //Port D 0-6 Output

    SPI_SEND_5004(0x05, 0x00, 0x00, 0x02);  //set SPI-Flag PE5004 BOARD SENSORS 

    // LED array and LED position correlation 
   LED_POSITION[0]=0;
   LED_POSITION[1]=4;
   LED_POSITION[2]=8;
   LED_POSITION[3]=12;
   LED_POSITION[4]=1;
   LED_POSITION[5]=5;
   LED_POSITION[6]=9;
   LED_POSITION[7]=13;
   LED_POSITION[8]=2;
   LED_POSITION[9]=6;
   LED_POSITION[10]=10;
   LED_POSITION[11]=14;
   LED_POSITION[12]=3;
   LED_POSITION[13]=7;
   LED_POSITION[14]=11;
   LED_POSITION[15]=15;
    
    // digit assignment
    SEVEN_SEG[0] = 0b11000000;
    SEVEN_SEG[1] = 0b11111001;
    SEVEN_SEG[2] = 0b10100100;
    SEVEN_SEG[3] = 0b10110000;
    SEVEN_SEG[4] = 0b10011001;
    SEVEN_SEG[5] = 0b10010010;
    SEVEN_SEG[6] = 0b10000010; 
    SEVEN_SEG[7] = 0b11111000; 
    SEVEN_SEG[8] = 0b10000000;
    SEVEN_SEG[9] = 0b10011000;
                  
//    terminal_puts(utoa(PCO, buf, 10));
//    terminal_puts(":");
//    terminal_puts(utoa(SAR_BASE[5], buf, 10));
//    terminal_puts("\n");

    // array inits
   for (count_var=0;count_var<16;count_var++){
      SAR_CALIB[count_var]=600; //reset SAR_CALIB  
      SAR_THRESH[count_var]=thresh; 
      SAR_FILT[count_var]= 0;
      SAR_DATA_old[count_var]= 0;
   }
   
    // load config PE5004
   LOAD_CONFIG_5004();
   
   //Routine for PCO-Calib (disable processing) terminal output
/* for (PCO=0; PCO<500; PCO++){

      SPI_SEND_5004( 0x04,0x00,(PCO >>8),PCO);
      COLSTART_ROWSTART=COLSTART_ROWSTART_SLIDER;
      COLEND_ROWEND=COLEND_ROWEND_SLIDER;
      sens_start=16;
      SPI_SEND_5004( 0x03,(SINA_SLIDER>>4 | SINF_SLIDER<<2),(PWR_SLIDER>>1 | SINA_SLIDER<<4),(GCO_DACREF_SLIDER | PWR_SLIDER<<7));
      RUN_MATRIX();
      terminal_puts(utoa(PCO, buf, 10));
      terminal_puts(":");
      terminal_puts(utoa(SAR_DATA_old[16], buf, 10));
      terminal_puts("\n");
      }while(1); 
*/
    
    //Matrix Calib
   SPI_SEND_5004( 0x04,0x00,(PCO_MATRIX >>8),PCO_MATRIX);
   COLSTART_ROWSTART=COLSTART_ROWSTART_MATRIX;
   COLEND_ROWEND=COLEND_ROWEND_MATRIX;
   sens_start=0;
   SPI_SEND_5004( 0x03,(SINA_MATRIX>>4 | SINF_MATRIX<<2),(PWR_MATRIX>>1 | SINA_MATRIX<<4),(GCO_DACREF_S3 | PWR_MATRIX<<7));
   CALIBRATE_MATRIX();

    //Slider Calib
   COLSTART_ROWSTART=COLSTART_ROWSTART_SLIDER;
   COLEND_ROWEND=COLEND_ROWEND_SLIDER;
   sens_start=16;
   SPI_SEND_5004( 0x03,(SINA_SLIDER>>4 | SINF_SLIDER<<2),(PWR_SLIDER>>1 | SINA_SLIDER<<4),(GCO_DACREF_SLIDER | PWR_SLIDER<<7));
   CALIBRATE_MATRIX();
   
    //slider vars
    runc = 0;
    pre_c1 = 0;
    summe1 = 0;
    i2_touch = 0;
    new_touch = 0;
    rel_c1 = 0;
    rel_old_c = 0;
    abs_c1 = 0;
   rel_temp_c = 0;
   abs_old_c = 0;
   abs_c1 = 45;



    //Main while
   while(1){


        //Matrix run
      COLSTART_ROWSTART=COLSTART_ROWSTART_MATRIX;
      COLEND_ROWEND=COLEND_ROWEND_MATRIX;
        sens_start=0;
      SPI_SEND_5004( 0x03,(SINA_MATRIX>>4 | SINF_MATRIX<<2),(PWR_MATRIX>>1 | SINA_MATRIX<<4),(GCO_DACREF_S3 | PWR_MATRIX<<7));
       RUN_MATRIX();
        
        //Slider run
       COLSTART_ROWSTART=COLSTART_ROWSTART_SLIDER;
       COLEND_ROWEND=COLEND_ROWEND_SLIDER;
       sens_start=16;
       SPI_SEND_5004( 0x03,(SINA_SLIDER>>4 | SINF_SLIDER<<2),(PWR_SLIDER>>1 | SINA_SLIDER<<4),(GCO_DACREF_SLIDER | PWR_SLIDER<<7));
      RUN_MATRIX();
       
      pFILT= &SAR_FILT[0];

      //MATRIX LEDs
      for (count=0; count<16; count++){
            if (*pFILT > 5){                 
            *pFILT= (((*pFILT)*(5))>>2);
                 if (*pFILT>200){
               LED_MATRIX_ARRAY[count] = 0x01;
                    }  
             else  {
               LED_MATRIX_ARRAY[count] = 0x00;
               }
            }
         else *pTHRESH=thresh;
            pFILT++;
      }
      leds_on = 0;
         for (count=0; count<16; count++){
            if (LED_MATRIX_ARRAY[count] == 0x01){
               LED_MATRIX = LED_POSITION[count];
               _delay_us(20);
               leds_on = 1;
            }
         }
        if (leds_on == 0){
         LED_MATRIX = 0x10;
      } 
        
        
//      Slider and 7-SEG routines
        pFILT= &SAR_FILT[16];
        pre_c1 = 0;
        summe1 = 0;

        //  pre calculating row "balance point"
      for (runc=3;runc<9;runc++){
            if (*pFILT > 5) 
            {
                  pre_c1 += runc**pFILT;
                  summe1 += *pFILT;
            }
            pFILT++;          
      }
      if ((summe1 > 20)&&(summe1 < 10000)) //old if ((summe1 > 15)&&(summe1 < 250)) //20
         {
         i2_touch=0;
         rel_c1 = ((pre_c1+(summe1>>1))/summe1); 
         if (new_touch == 1){
            rel_old_c = rel_c1;
            }
         if (rel_old_c > rel_c1){ //if new value lesser than rel_old_r move cursor left
            rel_temp_c = rel_old_c - rel_c1;
               abs_c1 = abs_old_c + (rel_temp_c);
            }
         if (rel_old_c < rel_c1){ //if new value larger than rel_old_r move cursor right
            rel_temp_c = rel_c1-rel_old_c;
               abs_c1 = abs_old_c - (rel_temp_c);
            }                 
         if (new_touch == 1){
            abs_c1 = abs_old_c ;
            new_touch = 0;
            }              
         //stop leaving the value field
         if (abs_c1 > 49)
            abs_c1 = 49; 
         if (abs_c1 < 40)
            abs_c1 = 40; 
      }
      else{ //find new touch (delay) 
         i2_touch++;  //increment i2_touch
         if(i2_touch>20){        //delay  
            i2_touch=0;
            new_touch = 1;
            }
         if (new_touch == 1){
            abs_old_c = abs_c1;
            }
      }
        //  7-SEG output 
        LED_SEVEN_SEG = SEVEN_SEG[abs_c1-40];
   }
    return 0;
}
