#include "defines.h"
#include "spi.h"
#include "main.h"
#include "timer.h"
#include "sensor_processing.h"
#include "terminal.h"



void CALIBRATE_MATRIX(void){
    uint8_t loop_calib=0; //reset loop_calib
   
     while(loop_calib<30){
      _delay_us(15);
      SPI_READ_5004_internal_sensors();
      SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
        COL_ROW = 0;
      pCALIB= &SAR_CALIB[sens_start];
        start_watchdog();
        while (1){
            if (INT_PORT & BIT(INT)){     
            SPI_READ_5004_internal_sensors();      //read sensordata        
                *pCALIB=(((*pCALIB)*3+SAR_DATA)>>2);
            pCALIB++; //increase pointer
                if (COL_ROW == COLEND_ROWEND)break; // break if last sensor is read
            while (INT_PORT & BIT(INT)){
               if (TIFR & 0x01){terminal_puts("timeout1\n");break;} // check for timeout
               SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
                }
            }
         if (TIFR & 0x01){terminal_puts("timeout2\n");break;} 
        }
        clear_watchdog();
        wait_107us();
        loop_calib++; //increase loop variable
    }
}


void RUN_MATRIX(void){
   _delay_us(15);
   SPI_READ_5004_internal_sensors();

   pCALIB= &SAR_CALIB[sens_start]; 
   pFILT= &SAR_FILT[sens_start];
   pSAR_DATA_old = &SAR_DATA_old[sens_start];
    
   SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
   COL_ROW = 0;
    start_watchdog();
   while (1){

        if (INT_PORT & BIT(INT)){

            SPI_READ_5004_internal_sensors();

         if ((abs((int)*pSAR_DATA_old-(int)SAR_DATA))<100){
            if (*pCALIB-10 > SAR_DATA){  //if measured data lesser then calibration data (touch lowers adc-value)
                  *pFILT=(((*pFILT<<1)+*pFILT+(*pCALIB-(SAR_DATA+thresh)))>>2); 
               }
            else *pFILT=(((*pFILT<<1)+*pFILT)>>3); //minimize current *pfilt value 
         }
         *pSAR_DATA_old=SAR_DATA;
         
         pSAR_DATA_old++;
         pCALIB++;
            pFILT++;

            if (COL_ROW == COLEND_ROWEND){break;} // break if last sensor is read
         while (INT_PORT & BIT(INT)){ //wait until interrupt low
            SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
         if (TIFR & 0x01)break;
         }
        }
    }
    clear_watchdog();
    wait_107us();
}    
