#include "defines.h"
#include "main.h"
#include "timer.h"
#include "terminal.h"


void start_watchdog(void)
{       
        TCNT0 = 170; // 78 cycles approx 10ms
        TCCR0 = ( 1<<CS02 | 1<<CS00 ); // start using prescaler clk/1024
   
}


void clear_watchdog(void)
{
    TIFR = 0x01; //clear Flags
}


void wait_107us(void)
{       
        OCR1A = 0x0D; // 10 cycles
        TCCR1A =( 1<<WGM12 ); // CTC-Mode
        TCCR1B = ( 1<<CS11 | 1<<CS10 ); // start using prescaler clk/64
        while (!(TIFR>>2)); // w8    
        TCCR1B = 0; //stop timer
        TCNT1 = 0; //clear timer
        TIFR = 0x07; //clear Flags
}

void pwmtimer(uint8_t bPWM)
{
            
        OCR1A = 0x12; // 18 cycles approx 144s
        TCCR1A =( 1<<WGM12 ); // CTC-Mode
        TCCR1B = ( 1<<CS11 | 1<<CS10 ); // start using prescaler clk/64
        while(bPWM){
            while (!(TIFR>>2)); // w8
            TIFR = 0x07; //clear Flags
            bPWM--;
        }
        TCCR1B = 0; //stop timer
        TCNT1 = 0; //clear timer
        TIFR = 0x07; //clear Flags
}


